xref: /openbmc/linux/scripts/link-vmlinux.sh (revision db16c1fe92d7ba7d39061faef897842baee2c887)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41	if [ "${quiet}" != "silent_" ]; then
42		printf "  %-7s %s\n" "${1}" "${2}"
43	fi
44}
45
46# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49	info GEN .tmp_initcalls.lds
50
51	${PYTHON} ${srctree}/scripts/jobserver-exec		\
52	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
53		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
54		> .tmp_initcalls.lds
55}
56
57# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61	info GEN .tmp_symversions.lds
62	rm -f .tmp_symversions.lds
63
64	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65		if [ -f ${o}.symversions ]; then
66			cat ${o}.symversions >> .tmp_symversions.lds
67		fi
68	done
69}
70
71# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
75	local objects
76	local lds=""
77
78	objects="--whole-archive				\
79		${KBUILD_VMLINUX_OBJS}				\
80		--no-whole-archive				\
81		--start-group					\
82		${KBUILD_VMLINUX_LIBS}				\
83		--end-group"
84
85	if [ -n "${CONFIG_LTO_CLANG}" ]; then
86		gen_initcalls
87		lds="-T .tmp_initcalls.lds"
88
89		if [ -n "${CONFIG_MODVERSIONS}" ]; then
90			gen_symversions
91			lds="${lds} -T .tmp_symversions.lds"
92		fi
93
94		# This might take a while, so indicate that we're doing
95		# an LTO link
96		info LTO ${1}
97	else
98		info LD ${1}
99	fi
100
101	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
102}
103
104objtool_link()
105{
106	local objtoolcmd;
107	local objtoolopt;
108
109	if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
110		# Don't perform vmlinux validation unless explicitly requested,
111		# but run objtool on vmlinux.o now that we have an object file.
112		if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
113			objtoolcmd="orc generate"
114		fi
115
116		objtoolopt="${objtoolopt} --duplicate"
117
118		if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
119			objtoolopt="${objtoolopt} --mcount"
120		fi
121	fi
122
123	if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
124		objtoolopt="${objtoolopt} --noinstr"
125	fi
126
127	if [ -n "${objtoolopt}" ]; then
128		if [ -z "${objtoolcmd}" ]; then
129			objtoolcmd="check"
130		fi
131		objtoolopt="${objtoolopt} --vmlinux"
132		if [ -z "${CONFIG_FRAME_POINTER}" ]; then
133			objtoolopt="${objtoolopt} --no-fp"
134		fi
135		if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
136			objtoolopt="${objtoolopt} --no-unreachable"
137		fi
138		if [ -n "${CONFIG_RETPOLINE}" ]; then
139			objtoolopt="${objtoolopt} --retpoline"
140		fi
141		if [ -n "${CONFIG_X86_SMAP}" ]; then
142			objtoolopt="${objtoolopt} --uaccess"
143		fi
144		info OBJTOOL ${1}
145		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
146	fi
147}
148
149# Link of vmlinux
150# ${1} - output file
151# ${2}, ${3}, ... - optional extra .o files
152vmlinux_link()
153{
154	local lds="${objtree}/${KBUILD_LDS}"
155	local output=${1}
156	local objects
157	local strip_debug
158
159	info LD ${output}
160
161	# skip output file argument
162	shift
163
164	# The kallsyms linking does not need debug symbols included.
165	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
166		strip_debug=-Wl,--strip-debug
167	fi
168
169	if [ "${SRCARCH}" != "um" ]; then
170		if [ -n "${CONFIG_LTO_CLANG}" ]; then
171			# Use vmlinux.o instead of performing the slow LTO
172			# link again.
173			objects="--whole-archive		\
174				vmlinux.o 			\
175				--no-whole-archive		\
176				${@}"
177		else
178			objects="--whole-archive		\
179				${KBUILD_VMLINUX_OBJS}		\
180				--no-whole-archive		\
181				--start-group			\
182				${KBUILD_VMLINUX_LIBS}		\
183				--end-group			\
184				${@}"
185		fi
186
187		${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}	\
188			${strip_debug#-Wl,}			\
189			-o ${output}				\
190			-T ${lds} ${objects}
191	else
192		objects="-Wl,--whole-archive			\
193			${KBUILD_VMLINUX_OBJS}			\
194			-Wl,--no-whole-archive			\
195			-Wl,--start-group			\
196			${KBUILD_VMLINUX_LIBS}			\
197			-Wl,--end-group				\
198			${@}"
199
200		${CC} ${CFLAGS_vmlinux}				\
201			${strip_debug}				\
202			-o ${output}				\
203			-Wl,-T,${lds}				\
204			${objects}				\
205			-lutil -lrt -lpthread
206		rm -f linux
207	fi
208}
209
210# generate .BTF typeinfo from DWARF debuginfo
211# ${1} - vmlinux image
212# ${2} - file to dump raw BTF data into
213gen_btf()
214{
215	local pahole_ver
216	local extra_paholeopt=
217
218	if ! [ -x "$(command -v ${PAHOLE})" ]; then
219		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
220		return 1
221	fi
222
223	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
224	if [ "${pahole_ver}" -lt "116" ]; then
225		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
226		return 1
227	fi
228
229	vmlinux_link ${1}
230
231	if [ "${pahole_ver}" -ge "121" ]; then
232		extra_paholeopt="${extra_paholeopt} --btf_gen_floats"
233	fi
234
235	info "BTF" ${2}
236	LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${extra_paholeopt} ${1}
237
238	# Create ${2} which contains just .BTF section but no symbols. Add
239	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
240	# deletes all symbols including __start_BTF and __stop_BTF, which will
241	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
242	# objcopy warnings: "empty loadable segment detected at ..."
243	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
244		--strip-all ${1} ${2} 2>/dev/null
245	# Change e_type to ET_REL so that it can be used to link final vmlinux.
246	# Unlike GNU ld, lld does not allow an ET_EXEC input.
247	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
248}
249
250# Create ${2} .S file with all symbols from the ${1} object file
251kallsyms()
252{
253	local kallsymopt;
254
255	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
256		kallsymopt="${kallsymopt} --all-symbols"
257	fi
258
259	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
260		kallsymopt="${kallsymopt} --absolute-percpu"
261	fi
262
263	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
264		kallsymopt="${kallsymopt} --base-relative"
265	fi
266
267	info KSYMS ${2}
268	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
269}
270
271# Perform one step in kallsyms generation, including temporary linking of
272# vmlinux.
273kallsyms_step()
274{
275	kallsymso_prev=${kallsymso}
276	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
277	kallsymso=${kallsyms_vmlinux}.o
278	kallsyms_S=${kallsyms_vmlinux}.S
279
280	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
281	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
282
283	info AS ${kallsyms_S}
284	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
285	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
286	      -c -o ${kallsymso} ${kallsyms_S}
287}
288
289# Create map file with all symbols from ${1}
290# See mksymap for additional details
291mksysmap()
292{
293	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
294}
295
296sorttable()
297{
298	${objtree}/scripts/sorttable ${1}
299}
300
301# Delete output files in case of error
302cleanup()
303{
304	rm -f .btf.*
305	rm -f .tmp_System.map
306	rm -f .tmp_initcalls.lds
307	rm -f .tmp_symversions.lds
308	rm -f .tmp_vmlinux*
309	rm -f System.map
310	rm -f vmlinux
311	rm -f vmlinux.o
312}
313
314on_exit()
315{
316	if [ $? -ne 0 ]; then
317		cleanup
318	fi
319}
320trap on_exit EXIT
321
322on_signals()
323{
324	exit 1
325}
326trap on_signals HUP INT QUIT TERM
327
328# Use "make V=1" to debug this script
329case "${KBUILD_VERBOSE}" in
330*1*)
331	set -x
332	;;
333esac
334
335if [ "$1" = "clean" ]; then
336	cleanup
337	exit 0
338fi
339
340# We need access to CONFIG_ symbols
341. include/config/auto.conf
342
343# Update version
344info GEN .version
345if [ -r .version ]; then
346	VERSION=$(expr 0$(cat .version) + 1)
347	echo $VERSION > .version
348else
349	rm -f .version
350	echo 1 > .version
351fi;
352
353# final build of init/
354${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
355
356#link vmlinux.o
357modpost_link vmlinux.o
358objtool_link vmlinux.o
359
360# modpost vmlinux.o to check for section mismatches
361${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
362
363info MODINFO modules.builtin.modinfo
364${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
365info GEN modules.builtin
366# The second line aids cases where multiple modules share the same object.
367tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
368	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
369
370btf_vmlinux_bin_o=""
371if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
372	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
373	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
374		echo >&2 "Failed to generate BTF for vmlinux"
375		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
376		exit 1
377	fi
378fi
379
380kallsymso=""
381kallsymso_prev=""
382kallsyms_vmlinux=""
383if [ -n "${CONFIG_KALLSYMS}" ]; then
384
385	# kallsyms support
386	# Generate section listing all symbols and add it into vmlinux
387	# It's a three step process:
388	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
389	#     but __kallsyms is empty.
390	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
391	#     the right size
392	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
393	#     the right size, but due to the added section, some
394	#     addresses have shifted.
395	#     From here, we generate a correct .tmp_kallsyms2.o
396	# 3)  That link may have expanded the kernel image enough that
397	#     more linker branch stubs / trampolines had to be added, which
398	#     introduces new names, which further expands kallsyms. Do another
399	#     pass if that is the case. In theory it's possible this results
400	#     in even more stubs, but unlikely.
401	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
402	#     other bugs.
403	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
404	#
405	# a)  Verify that the System.map from vmlinux matches the map from
406	#     ${kallsymso}.
407
408	kallsyms_step 1
409	kallsyms_step 2
410
411	# step 3
412	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
413	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
414
415	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
416		kallsyms_step 3
417	fi
418fi
419
420vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
421
422# fill in BTF IDs
423if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
424	info BTFIDS vmlinux
425	${RESOLVE_BTFIDS} vmlinux
426fi
427
428if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
429	info SORTTAB vmlinux
430	if ! sorttable vmlinux; then
431		echo >&2 Failed to sort kernel tables
432		exit 1
433	fi
434fi
435
436info SYSMAP System.map
437mksysmap vmlinux System.map
438
439# step a (see comment above)
440if [ -n "${CONFIG_KALLSYMS}" ]; then
441	mksysmap ${kallsyms_vmlinux} .tmp_System.map
442
443	if ! cmp -s System.map .tmp_System.map; then
444		echo >&2 Inconsistent kallsyms data
445		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
446		exit 1
447	fi
448fi
449